(window["webpackJsonp_name_"] = window["webpackJsonp_name_"] || []).push([[32],{

/***/ "./lib/app/ui/components/admin/shopify-menu/get-prices.jsx":
/*!*****************************************************************!*\
  !*** ./lib/app/ui/components/admin/shopify-menu/get-prices.jsx ***!
  \*****************************************************************/
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "POSSIBLE_PRICES_COUNT_LIMIT", function() { return POSSIBLE_PRICES_COUNT_LIMIT; });
/* harmony import */ var lodash_es__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! lodash-es */ "./node_modules/lodash-es/lodash.js");
/* harmony import */ var utils_async_helpers__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! utils/async/helpers */ "./lib/app/utils/async/helpers/index.jsx");


function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }



var POSSIBLE_PRICES_COUNT_LIMIT = 5000;
var EXECUTION_TIME_LIMIT = 1000;
var ERROR_COUNT_LIMIT = "The limit of ".concat(POSSIBLE_PRICES_COUNT_LIMIT, " product price combinations has been exceeded.");
var ERROR_TIME_LIMIT = 'Variant calculation time exceeded the allowed limit.';
var lastPossibleVariants = 1;
var executionTime = new Date().getTime();

function formatPrice(price) {
  /**
   * Format price to Number
   * @price {String|Integer|Float}
   * @return {Float}
   */
  return Number.parseFloat(price) || 0;
}

function idIndex(id, list) {
  /**
   * Gets the index of the item
   * in the list
   * based on the passed id
   * @id {String} - id to search
   * @list {Array} - array of Objects with id in one of key
   * @return {Integet} - index of element
   */
  var index = null;
  list.map(function (item, itemIndex) {
    if (item.id === id) index = itemIndex;
  });
  return index;
}

function getRuleKey(rule, Product) {
  /**
   * Returns a key consisting of panel indexes,
   * categories and options in "p-c-o" format
   *
   * @rule {Object} - rule object
   * @return {String} - rule key. Example: "1-2-0"
   */
  var rulePanelIndex = idIndex(rule.panel, Product.panels);
  var rulePanel = Product.panels[rulePanelIndex];
  if (!rulePanel) return;
  var rulePanelCategories = rulePanel.categories;
  var ruleCategoryIndex = idIndex(rule.category, rulePanelCategories);
  if (!rulePanelCategories[ruleCategoryIndex]) return null;
  var ruleOptionIndex = idIndex(rule.option, rulePanelCategories[ruleCategoryIndex].options);
  return "pan".concat(rulePanelIndex, "-cat").concat(ruleCategoryIndex, "-opt").concat(ruleOptionIndex);
}

function convertWithBasePrice(price, basePrice) {
  return lodash_es__WEBPACK_IMPORTED_MODULE_0__["default"].round(basePrice + price, 2);
}

function sumArrays(_x) {
  return _sumArrays.apply(this, arguments);
}

function _sumArrays() {
  _sumArrays = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee7(arrayOfArrays) {
    var basePrice,
        result,
        totalPriceCounter,
        newResult,
        _args7 = arguments;
    return regeneratorRuntime.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            basePrice = _args7.length > 1 && _args7[1] !== undefined ? _args7[1] : false;

            if (arrayOfArrays.length) {
              _context7.next = 3;
              break;
            }

            return _context7.abrupt("return", []);

          case 3:
            arrayOfArrays = lodash_es__WEBPACK_IMPORTED_MODULE_0__["default"].clone(arrayOfArrays);
            result = arrayOfArrays[0].slice();
            totalPriceCounter = 0;
            _context7.prev = 6;
            _context7.next = 9;
            return arrayOfArrays.reduce(
            /*#__PURE__*/
            function () {
              var _ref3 = _asyncToGenerator(
              /*#__PURE__*/
              regeneratorRuntime.mark(function _callee6(prev, arrayOperand, arrayIndex) {
                return regeneratorRuntime.wrap(function _callee6$(_context6) {
                  while (1) {
                    switch (_context6.prev = _context6.next) {
                      case 0:
                        return _context6.abrupt("return", new Promise(
                        /*#__PURE__*/
                        function () {
                          var _ref4 = _asyncToGenerator(
                          /*#__PURE__*/
                          regeneratorRuntime.mark(function _callee5(r1, reject) {
                            var data;
                            return regeneratorRuntime.wrap(function _callee5$(_context5) {
                              while (1) {
                                switch (_context5.prev = _context5.next) {
                                  case 0:
                                    _context5.prev = 0;

                                    if (arrayIndex) {
                                      _context5.next = 3;
                                      break;
                                    }

                                    return _context5.abrupt("return", r1(prev));

                                  case 3:
                                    if (!lodash_es__WEBPACK_IMPORTED_MODULE_0__["default"].isArray(prev)) {
                                      _context5.next = 7;
                                      break;
                                    }

                                    _context5.t0 = prev;
                                    _context5.next = 13;
                                    break;

                                  case 7:
                                    _context5.next = 9;
                                    return prev;

                                  case 9:
                                    _context5.t1 = _context5.sent;

                                    if (_context5.t1) {
                                      _context5.next = 12;
                                      break;
                                    }

                                    _context5.t1 = [];

                                  case 12:
                                    _context5.t0 = _context5.t1;

                                  case 13:
                                    data = _context5.t0;
                                    _context5.next = 16;
                                    return Promise.all(lodash_es__WEBPACK_IMPORTED_MODULE_0__["default"].clone(data).map(function (resultOperand) {
                                      return Object(utils_async_helpers__WEBPACK_IMPORTED_MODULE_1__["asyncDelay"])(
                                      /*#__PURE__*/
                                      _asyncToGenerator(
                                      /*#__PURE__*/
                                      regeneratorRuntime.mark(function _callee4() {
                                        return regeneratorRuntime.wrap(function _callee4$(_context4) {
                                          while (1) {
                                            switch (_context4.prev = _context4.next) {
                                              case 0:
                                                _context4.next = 2;
                                                return Promise.all(arrayOperand.map(
                                                /*#__PURE__*/
                                                function () {
                                                  var _ref6 = _asyncToGenerator(
                                                  /*#__PURE__*/
                                                  regeneratorRuntime.mark(function _callee3(item) {
                                                    var r, rBase;
                                                    return regeneratorRuntime.wrap(function _callee3$(_context3) {
                                                      while (1) {
                                                        switch (_context3.prev = _context3.next) {
                                                          case 0:
                                                            // if (stopLoop) return;
                                                            r = resultOperand + item;

                                                            if (data.includes(r)) {
                                                              _context3.next = 8;
                                                              break;
                                                            }

                                                            if (basePrice !== false) {
                                                              rBase = convertWithBasePrice(r, basePrice || 0);

                                                              if (rBase !== basePrice) {
                                                                totalPriceCounter += 1;
                                                              }
                                                            }

                                                            if (!(totalPriceCounter > POSSIBLE_PRICES_COUNT_LIMIT)) {
                                                              _context3.next = 7;
                                                              break;
                                                            }

                                                            throw Error(ERROR_COUNT_LIMIT);

                                                          case 7:
                                                            data.push(r);

                                                          case 8:
                                                          case "end":
                                                            return _context3.stop();
                                                        }
                                                      }
                                                    }, _callee3);
                                                  }));

                                                  return function (_x10) {
                                                    return _ref6.apply(this, arguments);
                                                  };
                                                }()));

                                              case 2:
                                              case "end":
                                                return _context4.stop();
                                            }
                                          }
                                        }, _callee4);
                                      })));
                                    }));

                                  case 16:
                                    r1(lodash_es__WEBPACK_IMPORTED_MODULE_0__["default"].uniq(data));
                                    _context5.next = 22;
                                    break;

                                  case 19:
                                    _context5.prev = 19;
                                    _context5.t2 = _context5["catch"](0);
                                    reject(ERROR_COUNT_LIMIT);

                                  case 22:
                                  case "end":
                                    return _context5.stop();
                                }
                              }
                            }, _callee5, null, [[0, 19]]);
                          }));

                          return function (_x8, _x9) {
                            return _ref4.apply(this, arguments);
                          };
                        }()));

                      case 1:
                      case "end":
                        return _context6.stop();
                    }
                  }
                }, _callee6);
              }));

              return function (_x5, _x6, _x7) {
                return _ref3.apply(this, arguments);
              };
            }(), lodash_es__WEBPACK_IMPORTED_MODULE_0__["default"].clone(result));

          case 9:
            newResult = _context7.sent;
            return _context7.abrupt("return", lodash_es__WEBPACK_IMPORTED_MODULE_0__["default"].uniq(newResult));

          case 13:
            _context7.prev = 13;
            _context7.t0 = _context7["catch"](6);
            console.error(_context7.t0);
            return _context7.abrupt("return", -1);

          case 17:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7, null, [[6, 13]]);
  }));
  return _sumArrays.apply(this, arguments);
}

var getPrices =
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2(Product, basePriceUnformatted) {
    var debug,
        dependents,
        priceGroups,
        percents,
        basePrice,
        pricesSeparatedByLogic,
        logicGroupedPrices,
        sumPriceGroups,
        sumArraysData,
        allAddonsPrices,
        withBasePrice,
        withPercents,
        _args2 = arguments;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            debug = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : false;

            /**
             * Returns all possible prices,
             * based on the fact that some categories
             * cannot exist simultaneously based on logic
             */
            dependents = {};
            priceGroups = [];
            percents = [];
            basePrice = formatPrice(basePriceUnformatted); // Collect prices and logics

            Product.panels.map(function (panel) {
              return panel.categories.map(function (category) {
                var categoryPrices = [];
                var isHaveZeroPrice = false;
                var categoryQuantityMultiplier = category.quantityMultiplier || 1; // Collect options prices to category

                category.options.map(function (option) {
                  var optionQuantityMultiplier = option.quantityMultiplier || 1;

                  if (category.type === 'percentage') {
                    // Filter percents
                    percents.push(formatPrice(option.price));
                    return;
                  }

                  if (!option.price) {
                    isHaveZeroPrice = true;
                    return;
                  }

                  if (option.logic && option.logic.rules && option.logic.rules.length && option.logic.action === 'hide') {
                    isHaveZeroPrice = true;
                  }

                  categoryPrices.push(formatPrice(option.price) * categoryQuantityMultiplier * optionQuantityMultiplier);
                });
                if (!categoryPrices.length) return;
                if (isHaveZeroPrice) categoryPrices.push(0); // Delete duplicates only for non-multiple categories

                if (!['multiple'].includes(category.type)) {
                  categoryPrices = lodash_es__WEBPACK_IMPORTED_MODULE_0__["default"].uniq(categoryPrices);
                }

                console.log('categoryPrices', categoryPrices);

                var appendPrices = function appendPrices(ruleKey, prices) {
                  // Append rule to depends
                  if (!dependents[ruleKey]) dependents[ruleKey] = [];

                  if (['multiple'].includes(category.type)) {
                    prices.map(function (price) {
                      return dependents[ruleKey].push([price]);
                    });
                  } else {
                    dependents[ruleKey].push(prices);
                  }
                }; // Separate logic-dependent and non-dependent prices


                if (category.logic && category.logic.rules && category.logic.rules.length) {
                  categoryPrices.push(0);
                  var ruleKey = '';
                  var rulePrices = [];
                  var validRules = 0;
                  category.logic.rules.map(function (rule, ruleIndex) {
                    var currentRuleKey = getRuleKey(rule, Product);
                    if (!currentRuleKey) return;
                    validRules++;

                    if (ruleIndex && rule.operator === '||') {
                      if (ruleKey.length) {
                        // Push previous "And" rules
                        appendPrices(ruleKey, categoryPrices);
                      } // Push current "Or" prices


                      appendPrices(currentRuleKey, categoryPrices); // Clear prices

                      ruleKey = '';
                    } else {
                      // Append logic key to previous "And" keys
                      ruleKey = ruleKey.length ? [ruleKey, currentRuleKey].join('+') : currentRuleKey;
                    }
                  });

                  if (ruleKey.length) {
                    // Push last "And" rules
                    appendPrices(ruleKey, categoryPrices);
                  } else {
                    // If there is no valid rules just add this price to the groups
                    if (!validRules) {
                      if (['multiple'].includes(category.type)) {
                        categoryPrices.map(function (price) {
                          return priceGroups.push([0, price]);
                        });
                      } else {
                        if (!category.required) categoryPrices.push(0);
                        priceGroups.push(categoryPrices);
                      }
                    }
                  }
                } else {
                  if (['multiple'].includes(category.type)) {
                    categoryPrices.map(function (price) {
                      return priceGroups.push([0, price]);
                    });
                  } else {
                    if (!category.required) categoryPrices.push(0);
                    priceGroups.push(categoryPrices);
                  }
                }
              });
            }); // Find all possible prices inside catogories with logic that is dependent on one category

            pricesSeparatedByLogic = {};
            executionTime = new Date().getTime();
            _context2.prev = 8;
            _context2.next = 11;
            return Promise.all(Object.keys(dependents).map(
            /*#__PURE__*/
            function () {
              var _ref2 = _asyncToGenerator(
              /*#__PURE__*/
              regeneratorRuntime.mark(function _callee(dependentKey) {
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return sumArrays(dependents[dependentKey], false);

                      case 2:
                        pricesSeparatedByLogic[dependentKey] = _context.sent;

                      case 3:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x4) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 11:
            _context2.next = 17;
            break;

          case 13:
            _context2.prev = 13;
            _context2.t0 = _context2["catch"](8);
            console.error(_context2.t0, 'Prices depentents:', dependents);
            return _context2.abrupt("return", -1);

          case 17:
            // Group prices by logic
            logicGroupedPrices = {};
            Object.keys(pricesSeparatedByLogic).map(function (dependentKey) {
              var logics = dependentKey.split('+');
              var groupIndex = '';
              logics.map(function (logic) {
                var indexes = logic.split('-');
                var key = "".concat(indexes[0], "-").concat(indexes[1]);
                groupIndex = groupIndex.length ? [groupIndex, key].join('+') : key;
              });
              if (!logicGroupedPrices[groupIndex]) logicGroupedPrices[groupIndex] = [];
              logicGroupedPrices[groupIndex] = lodash_es__WEBPACK_IMPORTED_MODULE_0__["default"].union(logicGroupedPrices[groupIndex], pricesSeparatedByLogic[dependentKey]);
            });

            if (debug) {
              console.log('Non logic based Price Groups', [].concat(priceGroups));
              console.log('Logic Dependents', dependents);
              console.log('Prices calculated by Logic Depends', pricesSeparatedByLogic);
              console.log('Prices depending on categories of logics', logicGroupedPrices);
            } // Add logic-based price groups to other non-logic price groups


            Object.keys(logicGroupedPrices).map(function (priceKey) {
              priceGroups.push(logicGroupedPrices[priceKey]);
            });
            sumPriceGroups = [];
            executionTime = new Date().getTime();
            _context2.prev = 23;
            _context2.next = 26;
            return sumArrays(priceGroups, basePrice);

          case 26:
            sumArraysData = _context2.sent;

            if (!(sumArraysData === -1)) {
              _context2.next = 29;
              break;
            }

            return _context2.abrupt("return", sumArraysData);

          case 29:
            sumPriceGroups = lodash_es__WEBPACK_IMPORTED_MODULE_0__["default"].isArray(sumArraysData) ? sumArraysData : [];
            _context2.next = 36;
            break;

          case 32:
            _context2.prev = 32;
            _context2.t1 = _context2["catch"](23);
            console.error(_context2.t1, 'Price Groups to calculate:', priceGroups);
            return _context2.abrupt("return", -1);

          case 36:
            // Sort prices
            allAddonsPrices = sumPriceGroups.sort(function (a, b) {
              return a - b;
            }); // Add product base price

            withBasePrice = lodash_es__WEBPACK_IMPORTED_MODULE_0__["default"].uniq(allAddonsPrices.map(function (price) {
              return convertWithBasePrice(price, basePrice);
            })).filter(function (price) {
              return price !== basePrice;
            }); // Remove base price from variants

            if (!(withBasePrice.length > POSSIBLE_PRICES_COUNT_LIMIT)) {
              _context2.next = 41;
              break;
            }

            console.error(ERROR_COUNT_LIMIT, withBasePrice);
            return _context2.abrupt("return", -1);

          case 41:
            if (!percents.length) {
              _context2.next = 51;
              break;
            }

            // Add prices with percents coefficient
            withPercents = withBasePrice.slice();
            percents.map(function (percent) {
              withBasePrice.map(function (price) {
                withPercents.push(Math.round(price * percent) / 100);
              });
            });
            withPercents = lodash_es__WEBPACK_IMPORTED_MODULE_0__["default"].uniq(withPercents);

            if (!(withPercents.length > POSSIBLE_PRICES_COUNT_LIMIT)) {
              _context2.next = 48;
              break;
            }

            console.error(ERROR_COUNT_LIMIT, withPercents);
            return _context2.abrupt("return", -1);

          case 48:
            return _context2.abrupt("return", withPercents.sort(function (a, b) {
              return a - b;
            }));

          case 51:
            return _context2.abrupt("return", withBasePrice);

          case 52:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[8, 13], [23, 32]]);
  }));

  return function getPrices(_x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

/* harmony default export */ __webpack_exports__["default"] = (getPrices);

/***/ }),

/***/ "./lib/app/ui/components/admin/shopify-menu/status-bar.jsx":
/*!*****************************************************************!*\
  !*** ./lib/app/ui/components/admin/shopify-menu/status-bar.jsx ***!
  \*****************************************************************/
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _fortawesome_react_fontawesome__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @fortawesome/react-fontawesome */ "./node_modules/@fortawesome/react-fontawesome/index.es.js");
/* harmony import */ var _fortawesome_free_solid_svg_icons__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @fortawesome/free-solid-svg-icons */ "./node_modules/@fortawesome/free-solid-svg-icons/index.es.js");
/* harmony import */ var utils_async__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! utils/async */ "./lib/app/utils/async/index.jsx");
/* harmony import */ var _get_prices__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./get-prices */ "./lib/app/ui/components/admin/shopify-menu/get-prices.jsx");
/* harmony import */ var lodash_es__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! lodash-es */ "./node_modules/lodash-es/lodash.js");
/* harmony import */ var utils_store_getters__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! utils/store/getters */ "./lib/app/utils/store/getters.jsx");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? Object(arguments[i]) : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }








var POSSIBLE_PRICES_COUNT_LIMIT = 5000;
/**
 * @class StatusBar
 * @classdesc Shows status bar menu
 * @memberof module:app/ui/components/admin/shopify-menu/status-bar
 * */

var StatusBar =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(StatusBar, _React$PureComponent);

  var _super = _createSuper(StatusBar);

  function StatusBar() {
    var _this;

    _classCallCheck(this, StatusBar);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      isOpen: false,
      pricesTotal: [],
      actions: [],
      actionsTotal: 0,
      isDone: false,
      requestDelay: 0,
      productsToDelete: [],
      debug: false,
      lastOperation: null
    });

    _defineProperty(_assertThisInitialized(_this), "isDoNotEditRequestSent", false);

    _defineProperty(_assertThisInitialized(_this), "isDoNotEditListEmpty", false);

    _defineProperty(_assertThisInitialized(_this), "pricesInline", '');

    _defineProperty(_assertThisInitialized(_this), "foundedPricesLength", 0);

    _defineProperty(_assertThisInitialized(_this), "variants", []);

    _defineProperty(_assertThisInitialized(_this), "pregenerateCounter", 1);

    return _this;
  }

  _createClass(StatusBar, [{
    key: "toggleDebug",
    value: function toggleDebug() {
      var _this2 = this;

      this.setState({
        debug: !this.state.debug
      }, function () {
        return _this2.updatePrices(true);
      });
    }
    /**
     * Get all options prices in one line
     */

  }, {
    key: "getPricesString",
    value: function getPricesString() {
      var _this$props = this.props,
          Product = _this$props.Product,
          pregeneratedProductName = _this$props.pregeneratedProductName;
      var isAutoGenerationOff = Product.isAutoGenerationOff;
      var prices = Product.base.price ? (+Product.base.price).toFixed(2) : '';
      prices += pregeneratedProductName;
      Product.panels.map(function (panel) {
        return panel.categories.map(function (category) {
          prices += category.type;
          prices += JSON.stringify(category.logic);
          category.options.map(function (option) {
            prices += option.price;
          });
        });
      });
      prices += isAutoGenerationOff ? 'manual' : 'auto';
      return prices;
    }
  }, {
    key: "getProductsToDelete",
    value: function getProductsToDelete() {
      var _this3 = this;

      var productsToDelete = this.state.productsToDelete;
      var _this$props2 = this.props,
          updateGeneratorNotice = _this$props2.updateGeneratorNotice,
          Product = _this$props2.Product;
      return new Promise(function (resolve, reject) {
        if (!_this3.isDoNotEditRequestSent && !productsToDelete.length) {
          _this3.isDoNotEditRequestSent = true;
          Object(utils_async__WEBPACK_IMPORTED_MODULE_3__["getRelatedProducts"])().bind(_this3)().done(function (response) {
            var productsList = response.productsList;
            _this3.isDoNotEditRequestSent = false;

            if (!productsList || !productsList.length) {
              _this3.isDoNotEditListEmpty = true;
              resolve([]);
            } else {
              updateGeneratorNotice('updated');

              _this3.setState({
                productsToDelete: response.productsList
              }, resolve(response.productsList));
            }
          }).fail(function (error) {
            return reject(error);
          }); // getDoNotEditProducts()(Product.name).done(response => {
          //     const { productsList } = response;
          //     this.isDoNotEditRequestSent = false;
          //     if (!productsList || !productsList.length) {
          //         this.isDoNotEditListEmpty = true;
          //         resolve([]);
          //     } else {
          //         updateGeneratorNotice('updated');
          //         this.setState({productsToDelete: response.productsList},
          //             resolve(response.productsList));
          //     }
          // })
        } else {
          resolve(productsToDelete);
        }
      });
    }
  }, {
    key: "updatePrices",
    value: function () {
      var _updatePrices = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var force,
            _this$props3,
            Product,
            Generator,
            updateGeneratorNotice,
            variants,
            updateProductData,
            isAutoGenerationOff,
            notice,
            basePrice,
            debug,
            isFirstPass,
            pricesInline,
            prices,
            appPrices,
            differenceNewToOld,
            differenceOldToNew,
            difference,
            _args = arguments;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                force = _args.length > 0 && _args[0] !== undefined ? _args[0] : false;

                if (!this.state.actions.length) {
                  _context.next = 3;
                  break;
                }

                return _context.abrupt("return");

              case 3:
                _this$props3 = this.props, Product = _this$props3.Product, Generator = _this$props3.Generator, updateGeneratorNotice = _this$props3.updateGeneratorNotice, variants = _this$props3.variants, updateProductData = _this$props3.updateProductData;
                isAutoGenerationOff = Product.isAutoGenerationOff;
                notice = Generator.notice;
                basePrice = variants[0] ? variants[0].price : Product.base.price;
                debug = this.state.debug;
                isFirstPass = !this.pricesInline.length; // Check if prices have changed

                pricesInline = this.getPricesString();

                if (!(pricesInline === this.pricesInline && !force && !isFirstPass && this.foundedPricesLength === variants.length)) {
                  _context.next = 14;
                  break;
                }

                return _context.abrupt("return");

              case 14:
                this.pricesInline = pricesInline;

              case 15:
                this.foundedPricesLength = variants.length;
                _context.next = 18;
                return Object(_get_prices__WEBPACK_IMPORTED_MODULE_4__["default"])(lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].cloneDeep(Product), basePrice, debug);

              case 18:
                prices = _context.sent;
                if (debug) console.log('prices', prices);

                if (!(prices < 0)) {
                  _context.next = 25;
                  break;
                }

                if (!Product.isNotPregenerated) {
                  // Make product is not pregenerated
                  updateProductData(_objectSpread({}, Product, {
                    isNotPregenerated: true
                  }), true);
                }

                return _context.abrupt("return");

              case 25:
                if (Product.isNotPregenerated) {
                  // Make product is pregenerated with variants
                  updateProductData(_objectSpread({}, Product, {
                    isNotPregenerated: false
                  }), true);
                }

              case 26:
                appPrices = variants.map(function (variant) {
                  return Number(variant.price);
                });

                if (prices.length && prices[0] === Number(basePrice)) {
                  if (lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].isArray(appPrices)) appPrices = appPrices.sort(function (a, b) {
                    return a - b;
                  });
                } else {
                  if (lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].isArray(appPrices)) appPrices = lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].drop(appPrices).sort(function (a, b) {
                    return a - b;
                  });
                }

                differenceNewToOld = lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].difference(prices, appPrices);
                differenceOldToNew = lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].difference(appPrices, prices);
                difference = [].concat(_toConsumableArray(differenceNewToOld), _toConsumableArray(differenceOldToNew));

                if (debug || isFirstPass) {
                  console.log('prices differenceNewToOld', differenceNewToOld);
                  console.log('prices differenceOldToNew', differenceOldToNew);
                  console.debug('[StatusBar] founded prices', appPrices);
                } // Update notice


                if (isAutoGenerationOff) {
                  if (this.getPreGenerationConflictCategories.check) {
                    updateGeneratorNotice('conflict');
                  } else {
                    if (difference.length) {
                      if (notice !== 'updated') updateGeneratorNotice('updated');
                    } else {
                      if (notice !== 'done') updateGeneratorNotice('done');
                    }
                  }
                } else {
                  if (differenceOldToNew.length) {
                    if (notice !== 'updated') updateGeneratorNotice('updated');
                  } else {
                    if (notice !== 'done') updateGeneratorNotice('done');
                  }
                }

                this.setState({
                  pricesTotal: prices
                });

              case 34:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function updatePrices() {
        return _updatePrices.apply(this, arguments);
      }

      return updatePrices;
    }()
  }, {
    key: "updateAutoGenerationCheckbox",
    value: function updateAutoGenerationCheckbox() {
      var _this$props4 = this.props,
          Product = _this$props4.Product,
          updateProductData = _this$props4.updateProductData,
          resetProduct = _this$props4.resetProduct,
          updateProductLayer = _this$props4.updateProductLayer,
          settings = _this$props4.settings;
      var isAutoGenerationOff = !Product.isAutoGenerationOff;
      updateProductData(_objectSpread({}, Product, {
        isAutoGenerationOff: isAutoGenerationOff
      }), true);
      resetProduct({
        defaultOptions: settings.defaultOptions,
        panels: Product.panels,
        base: Product.base,
        settings: settings,
        onceCalculate: true
      });
      updateProductLayer({
        layers: []
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var variants = this.props.variants;
      this.variants = variants;
      this.updatePrices();
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps() {
      this.updatePrices();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.updatePrices();
    }
  }, {
    key: "toggleOpen",
    value: function toggleOpen() {
      this.setState({
        isOpen: !this.state.isOpen
      });
    }
  }, {
    key: "process",
    value: function process() {
      var _this4 = this;

      var _this$state = this.state,
          actions = _this$state.actions,
          productsToDelete = _this$state.productsToDelete;
      var _this$props5 = this.props,
          Product = _this$props5.Product,
          updateProductVariants = _this$props5.updateProductVariants,
          updateGeneratorProcessing = _this$props5.updateGeneratorProcessing,
          updateGeneratorNotice = _this$props5.updateGeneratorNotice,
          variants = _this$props5.variants,
          pregeneratedProductName = _this$props5.pregeneratedProductName; // Apply product name templates

      var productName = pregeneratedProductName;
      var nameTemplates = [{
        text: '{{counter}}',
        value: this.pregenerateCounter
      }, {
        text: '{{product_title}}',
        value: Product.name
      }];
      nameTemplates.map(function (template) {
        return productName = lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].replace(productName, template.text, template.value);
      });

      if (actions.length) {
        var action = actions[0];

        if (action.type === 'delete') {
          this.setState({
            lastOperation: 'delete'
          });
          Object(utils_async__WEBPACK_IMPORTED_MODULE_3__["deleteShopProduct"])().bind(this)(action.id).done(function (response) {
            console.log('deleteShopProduct', {
              title: action.data.title,
              product: action.data,
              response: response
            });

            _this4.setState({
              actions: lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].drop(actions),
              requestDelay: 0
            }, _this4.process);
          }).fail(function (error) {
            console.error("Can't delete generated product", error);
            updateGeneratorNotice('error');
          });
        } else {
          this.setState({
            lastOperation: 'generation'
          });

          if (action.isFirstPart && variants.length) {
            Object(utils_async__WEBPACK_IMPORTED_MODULE_3__["updateOriginalProductVariants"])().bind(this)(action.prices, variants[0].id).done(function (response) {
              console.log('updateOriginalProductVariants', response);

              _this4.setState({
                actions: lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].drop(actions),
                requestDelay: 0
              }, _this4.process);
            }).fail(function (error) {
              console.error("Can't update original product", error);
              updateGeneratorNotice('error');
            });
          } else {
            Object(utils_async__WEBPACK_IMPORTED_MODULE_3__["generateProductVariants"])().bind(this)(action.prices, {
              name: Product.name
            }, productName).done(function (response) {
              console.log('generateProductVariants', response);

              _this4.setState({
                actions: lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].drop(actions),
                requestDelay: 0
              }, _this4.process);
            }).fail(function (error) {
              console.error("Can't create generated product", error);
              updateGeneratorNotice('error');
            });
            this.pregenerateCounter++;
          }
        }
      } else {
        if (productsToDelete && productsToDelete.length) {
          this.setState({
            productsToDelete: []
          }, function () {
            _this4.getProductsToDelete().then(function (productsToDelete) {
              productsToDelete.map(function (product) {
                return actions.push({
                  type: 'delete',
                  id: product.id,
                  data: product
                });
              });

              _this4.setState({
                actions: actions,
                isDone: false,
                actionsTotal: actions.length
              }, _this4.process);
            });
          });
        } else {
          this.finishProcess();
        }
      }
    }
  }, {
    key: "finishProcess",
    value: function finishProcess() {
      var _this5 = this;

      var _this$props6 = this.props,
          Product = _this$props6.Product,
          updateProductVariants = _this$props6.updateProductVariants,
          updateGeneratorProcessing = _this$props6.updateGeneratorProcessing,
          updateGeneratorNotice = _this$props6.updateGeneratorNotice;
      Object(utils_async__WEBPACK_IMPORTED_MODULE_3__["getShopProduct"])().bind(this)().done(function (res) {
        _this5.variants = res.variants;
        Object(utils_async__WEBPACK_IMPORTED_MODULE_3__["getRelatedProducts"])().bind(_this5)().done(function (res) {
          if (res.productsList && res.productsList.length) {
            res.productsList.map(function (product) {
              product.variants.map(function (variant) {
                return _this5.variants.push(variant);
              });
            });
          }

          updateProductVariants(_this5.variants);
          updateGeneratorNotice('done');
        }).fail(function (error) {
          console.error("[Variants Generator] Can't get Product Variants", error);
          updateGeneratorNotice('error');
        }).always(function () {
          _this5.setState({
            lastOperation: 'done'
          });
        });
      }).fail(function (error) {
        console.error("[Variants Generator] Can't get shop Product", error);
        updateGeneratorNotice('error');

        _this5.setState({
          lastOperation: 'done'
        });
      }).always(function () {
        updateGeneratorProcessing(false);

        _this5.setState({
          isDone: true,
          actionsTotal: 0
        });
      });
    }
  }, {
    key: "runProcessing",
    value: function () {
      var _runProcessing = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee2() {
        var _this6 = this;

        var _this$props7, Product, updateGeneratorProcessing, updateGeneratorNotice, variants, isAutoGenerationOff, basePrice, prices, actions, pricesList;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _this$props7 = this.props, Product = _this$props7.Product, updateGeneratorProcessing = _this$props7.updateGeneratorProcessing, updateGeneratorNotice = _this$props7.updateGeneratorNotice, variants = _this$props7.variants;
                isAutoGenerationOff = Product.isAutoGenerationOff;
                basePrice = variants[0] ? variants[0].price : Product.base.price;
                _context2.next = 5;
                return Object(_get_prices__WEBPACK_IMPORTED_MODULE_4__["default"])(Product, basePrice);

              case 5:
                prices = _context2.sent;
                actions = [{
                  type: 'get'
                }];
                pricesList = prices;
                updateGeneratorProcessing(true);
                updateGeneratorNotice('process');
                this.setState({
                  actions: actions,
                  isDone: false
                });
                this.pregenerateCounter = 1;

                if (prices < 0 || !isAutoGenerationOff) {
                  this.getProductsToDelete().then(function (productsToDelete) {
                    // Add action for clearing the original product variants
                    actions.push({
                      type: 'add',
                      prices: [],
                      isFirstPart: true
                    }); // Add othed delete actions

                    productsToDelete.map(function (product) {
                      return actions.push({
                        type: 'delete',
                        id: product.id,
                        data: product,
                        isFirstPart: false
                      });
                    });

                    _this6.setState({
                      actions: lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].drop(actions),
                      isDone: false,
                      actionsTotal: actions.length
                    }, _this6.process);
                  });
                } else {
                  this.getProductsToDelete().then(function (productsToDelete) {
                    productsToDelete.map(function (product) {
                      return actions.push({
                        type: 'delete',
                        id: product.id,
                        data: product
                      });
                    });
                    Object(utils_async__WEBPACK_IMPORTED_MODULE_3__["getRelatedProducts"])().bind(_this6)().done(function (related) {
                      related.productsList.map(function (product) {
                        return actions.push({
                          type: 'delete',
                          id: product.id,
                          data: product
                        });
                      });
                    }).always(function () {
                      var isFirstPart = true;

                      do {
                        actions.push({
                          type: 'add',
                          prices: lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].slice(pricesList, 0, 95),
                          isFirstPart: isFirstPart
                        });
                        pricesList = lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].drop(pricesList, 95);
                        isFirstPart = false;
                      } while (pricesList.length);

                      _this6.setState({
                        actions: lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].drop(actions),
                        isDone: false,
                        actionsTotal: actions.length
                      }, _this6.process);
                    });
                  });
                }

              case 13:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function runProcessing() {
        return _runProcessing.apply(this, arguments);
      }

      return runProcessing;
    }()
  }, {
    key: "getConflictsCategoriesText",
    value: function getConflictsCategoriesText() {
      var conflictCategories = this.getPreGenerationConflictCategories.categories;

      var getTypeNames = lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].uniq(conflictCategories.map(function (c) {
        return "\"".concat(c.typeName, "\"");
      }));

      var getNamesList = lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].map(conflictCategories, function (c, i) {
        return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("li", {
          key: "".concat(c.type, "_").concat(i)
        }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("strong", null, "\"", c.panel.title, "\" - \"", c.title, "\";"));
      });

      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", {
        className: 'cpb-error'
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("strong", null, " Variants pre-generation does not work because your configuration contains the following category ", conflictCategories.length > 1 ? 'types' : 'type', " ", getTypeNames.join(', '), ":"), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("ul", null, getNamesList));
    }
  }, {
    key: "render",
    value: function render() {
      var _this7 = this;

      var _this$props8 = this.props,
          Product = _this$props8.Product,
          Generator = _this$props8.Generator,
          variants = _this$props8.variants,
          toggleGeneratorPopup = _this$props8.toggleGeneratorPopup;
      var isAutoGenerationOff = Product.isAutoGenerationOff === true;
      var isOpen = Generator.isOpen,
          notice = Generator.notice;
      var _this$state2 = this.state,
          actions = _this$state2.actions,
          actionsTotal = _this$state2.actionsTotal,
          requestDelay = _this$state2.requestDelay,
          debug = _this$state2.debug,
          lastOperation = _this$state2.lastOperation,
          pricesTotal = _this$state2.pricesTotal;
      var percents = actionsTotal ? Math.floor((actionsTotal - actions.length) / actionsTotal * 100) : 100;
      if (!isOpen) return null;
      var isHaveQuantityDependencies = Product.panels.map(function (panel) {
        return panel.categories.filter(function (category) {
          return category.quantitySource;
        });
      }).length;

      if (false) {}

      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", {
        className: "cpb-status ".concat(isOpen ? 'cpb-opened' : 'cpb-closed')
      }, actions.length || lodash_es__WEBPACK_IMPORTED_MODULE_5__["default"].includes(['delete', 'generation'], lastOperation) ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", {
        className: "cpb-status-bar"
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", {
        className: "cpb-status-bar-progress",
        style: {
          width: "".concat(percents, "%")
        }
      }), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", {
        className: "cpb-status-bar-text"
      }, actions.length ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null, actions[0].type === 'delete' && 'Deleting previous prices', actions[0].type === 'add' && !actions[0].isFirstPart && 'Creating new prices', actions[0].type === 'add' && actions[0].isFirstPart && 'Updating the original product', actions[0].type === 'get' && 'Getting product info', actionsTotal && actions[0].type !== 'get' ? " ".concat(percents, "%") : '') : 'Finishing')), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", {
        className: "cpb-status-text"
      }, requestDelay ? 'Too Many Requests problem. Please try again later.' : 'Please stay on this page until the process is complete.')) : react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", {
        className: "cpb-status-text"
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("button", {
        className: "cpb-menu-link cpb-dark cpb-menu-toggle-".concat(!isAutoGenerationOff ? 'on' : 'off'),
        onClick: function onClick() {
          return _this7.updateAutoGenerationCheckbox();
        }
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_fortawesome_react_fontawesome__WEBPACK_IMPORTED_MODULE_1__["FontAwesomeIcon"], {
        icon: !isAutoGenerationOff ? _fortawesome_free_solid_svg_icons__WEBPACK_IMPORTED_MODULE_2__["faToggleOn"] : _fortawesome_free_solid_svg_icons__WEBPACK_IMPORTED_MODULE_2__["faToggleOff"]
      }), "\xA0Generate a custom product on each Add to Cart"), "It will have customized image and SKU in the SKU field in the cart and checkout."), notice === 'conflict' ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", {
        className: "cpb-status-text cpb-status-text-full-w"
      }, this.getConflictsCategoriesText()) : !Product.isNotPregenerated ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", {
        className: "cpb-status-text"
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("h3", null, "IMPORTANT:"), isAutoGenerationOff ? !notice || notice === 'done' ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null, "Product can be added to cart", react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("br", null), "(", pricesTotal.length, " variants exists)") : react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null, "This product won't add to cart", isHaveQuantityDependencies && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null, "\xA0because you have dependencies of the quantities of options on other categories"), ".", react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("br", null), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("br", null), "Please click \"Create Variants\" to generate product variants.", react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("br", null), "(", pricesTotal.length, " variants can be created out of ~", POSSIBLE_PRICES_COUNT_LIMIT, " allowed)") : react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null, "Copies of that product will be created on each Add to Cart so they can be added to the order.", variants.length > 1 ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("br", null), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("br", null), "Please click \"Delete Old Variants\" to delete unnecessary generated variants.", react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("br", null), "(You can delete ", variants.length - 1, " unnecessary product variants)") : '', react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("br", null), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("br", null), "Or you can turn off auto-generation with the switch above to generate all possible options in advance."), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("br", null), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("a", {
        href: "https://buildateam.zendesk.com/hc/en-us/articles/360028259451--DO-NOT-DELETE-OR-EDIT-Products-Shopify-Variant-Limit-",
        target: "_blank"
      }, "Read more...")), isAutoGenerationOff ? notice && notice !== 'done' ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", {
        className: "cpb-status-form"
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("button", {
        className: "cpb-button cpb-primary",
        onClick: function onClick() {
          return _this7.runProcessing();
        }
      }, "Create Variants")) : '' : variants.length > 1 ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", {
        className: "cpb-status-form"
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("button", {
        className: "cpb-button cpb-primary",
        onClick: function onClick() {
          return _this7.runProcessing();
        }
      }, "Delete Old Variants")) : '') : react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", {
        className: "cpb-status-text"
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("h3", null, "IMPORTANT:"), "The limit of ", POSSIBLE_PRICES_COUNT_LIMIT, " product price combinations has been exceeded. Pre-generation of price variants is not supported at this limit", isAutoGenerationOff ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null, ", ", react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("b", null, "please switch generate mode", variants.length > 1 ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null, " and delete old variants") : react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null)), ".") : react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(react__WEBPACK_IMPORTED_MODULE_0___default.a.Fragment, null, "."), " In order to allow to add custom products to cart - a new simple product related to custom product will be created each time someone places an order for custom products with generated total product price.", react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("br", null), "Check Inspect > Console to see how many price combinations you have.", react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("br", null), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("a", {
        href: "https://buildateam.zendesk.com/hc/en-us/articles/360028259451--DO-NOT-DELETE-OR-EDIT-Products-Shopify-Variant-Limit-",
        target: "_blank"
      }, "Read more..."), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("br", null), !isAutoGenerationOff && variants.length > 1 && react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", {
        className: "cpb-status-form"
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("button", {
        className: "cpb-button cpb-primary",
        onClick: function onClick() {
          return _this7.runProcessing();
        }
      }, "Delete Old Variants")))), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("button", {
        className: "cpb-menu-link cpb-dark cpb-menu-toggle-".concat(debug ? 'on' : 'off', " cpb-debug"),
        title: "Turn on logging to the console",
        style: {
          position: 'absolute',
          right: '10px',
          bottom: '10px'
        },
        onClick: function onClick() {
          return _this7.toggleDebug();
        }
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_fortawesome_react_fontawesome__WEBPACK_IMPORTED_MODULE_1__["FontAwesomeIcon"], {
        icon: debug ? _fortawesome_free_solid_svg_icons__WEBPACK_IMPORTED_MODULE_2__["faToggleOn"] : _fortawesome_free_solid_svg_icons__WEBPACK_IMPORTED_MODULE_2__["faToggleOff"]
      }), " Debug"), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("button", {
        className: "cpb-close",
        title: "Close Generator",
        onClick: function onClick() {
          return toggleGeneratorPopup();
        }
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_fortawesome_react_fontawesome__WEBPACK_IMPORTED_MODULE_1__["FontAwesomeIcon"], {
        icon: _fortawesome_free_solid_svg_icons__WEBPACK_IMPORTED_MODULE_2__["faTimes"]
      })));
    }
  }, {
    key: "getPreGenerationConflictCategories",
    get: function get() {
      return Object(utils_store_getters__WEBPACK_IMPORTED_MODULE_6__["g_checkPreGenerationConflictCategories"])(this.props.Product.panels);
    }
  }]);

  return StatusBar;
}(react__WEBPACK_IMPORTED_MODULE_0___default.a.PureComponent);

_defineProperty(StatusBar, "displayName", 'StatusBar');

/* harmony default export */ __webpack_exports__["default"] = (StatusBar);

/***/ })

}]);
//# sourceMappingURL=32.053d36c55bc5967fe179d76545038895f1621190.js.map?id=1043f24fb06838d60bc9