(window["webpackJsonp_name_"] = window["webpackJsonp_name_"] || []).push([[35],{

/***/ "./lib/app/ui/components/admin/shopify-menu/index.jsx":
/*!************************************************************!*\
  !*** ./lib/app/ui/components/admin/shopify-menu/index.jsx ***!
  \************************************************************/
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "./node_modules/react/index.js");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _fortawesome_react_fontawesome__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @fortawesome/react-fontawesome */ "./node_modules/@fortawesome/react-fontawesome/index.es.js");
/* harmony import */ var _fortawesome_free_regular_svg_icons__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @fortawesome/free-regular-svg-icons */ "./node_modules/@fortawesome/free-regular-svg-icons/index.es.js");
/* harmony import */ var _fortawesome_free_solid_svg_icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @fortawesome/free-solid-svg-icons */ "./node_modules/@fortawesome/free-solid-svg-icons/index.es.js");
/* harmony import */ var utils_icons_loading__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! utils/icons/loading */ "./lib/app/utils/icons/loading.jsx");


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }






var StatusBar = Object(react__WEBPACK_IMPORTED_MODULE_0__["lazy"])(function () {
  return __webpack_require__.e(/*! import() */ 32).then(__webpack_require__.bind(null, /*! ./status-bar */ "./lib/app/ui/components/admin/shopify-menu/status-bar.jsx"));
});
/**
 * @class ShopifyMenu
 * @classdesc Shows Shopify admin menu
 * @memberof module:app/ui/components/admin/shopify-menu
 * */

var ShopifyMenu =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(ShopifyMenu, _React$PureComponent);

  var _super = _createSuper(ShopifyMenu);

  function ShopifyMenu() {
    _classCallCheck(this, ShopifyMenu);

    return _super.apply(this, arguments);
  }

  _createClass(ShopifyMenu, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          onBack = _this$props.onBack,
          onSave = _this$props.onSave,
          onHelp = _this$props.onHelp,
          onSettings = _this$props.onSettings,
          onTheme = _this$props.onTheme,
          toggleAdmin = _this$props.toggleAdmin,
          Routing = _this$props.Routing,
          isAdmin = _this$props.isAdmin,
          Product = _this$props.Product,
          Generator = _this$props.Generator,
          updateGeneratorNotice = _this$props.updateGeneratorNotice,
          updateProductData = _this$props.updateProductData,
          toggleGeneratorPopup = _this$props.toggleGeneratorPopup,
          variants = _this$props.variants,
          updateProductVariants = _this$props.updateProductVariants,
          updateGeneratorProcessing = _this$props.updateGeneratorProcessing,
          pregeneratedProductName = _this$props.pregeneratedProductName,
          resetProduct = _this$props.resetProduct,
          settings = _this$props.settings,
          updateProductLayer = _this$props.updateProductLayer;
      var notice = Generator.notice,
          isProcessing = Generator.isProcessing;
      var isNotPregenerated = Product.isNotPregenerated;
      var productId = Routing.productId,
          productHandle = Routing.productHandle,
          shopName = Routing.shopName;
      var productLink = 'https://' + shopName + '.myshopify.com/admin/products/' + productId;
      var previewLink = 'https://' + shopName + '.myshopify.com/products/' + productHandle;
      var generatorNotice = null;

      switch (notice) {
        case 'conflict':
          generatorNotice = 'Generator has some conflicts.';
          break;

        case 'done':
          generatorNotice = 'Variants generated successfully.';
          break;

        case 'error':
          generatorNotice = 'Variant generation error.';
          break;

        case 'process':
          generatorNotice = 'Variant generation is in process.';
          break;

        case 'updated':
          generatorNotice = 'You have many prices variants. ' + 'Please generate it here before Product using' + 'so that your customers can add the Product to the cart';
          break;

        default:
      }

      return react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", {
        className: "cpb-menu"
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", {
        className: "cpb-menu-part"
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("button", {
        className: "cpb-menu-link",
        title: "Go back to the Products list",
        onClick: onBack
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_fortawesome_react_fontawesome__WEBPACK_IMPORTED_MODULE_1__["FontAwesomeIcon"], {
        icon: _fortawesome_free_solid_svg_icons__WEBPACK_IMPORTED_MODULE_3__["faChevronLeft"]
      }), " Back"), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("button", {
        className: "cpb-menu-link",
        title: "Open product General Setting popup",
        onClick: onSettings
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_fortawesome_react_fontawesome__WEBPACK_IMPORTED_MODULE_1__["FontAwesomeIcon"], {
        icon: _fortawesome_free_solid_svg_icons__WEBPACK_IMPORTED_MODULE_3__["faTools"]
      }), " Settings"), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("button", {
        className: "cpb-menu-link",
        title: "Open Theme switching popup",
        onClick: onTheme
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_fortawesome_react_fontawesome__WEBPACK_IMPORTED_MODULE_1__["FontAwesomeIcon"], {
        icon: _fortawesome_free_solid_svg_icons__WEBPACK_IMPORTED_MODULE_3__["faPaintBrush"]
      }), " Theme"), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("a", {
        className: "cpb-menu-link",
        href: productLink,
        title: "Open this Product in Shopify product editor in a new Tab",
        target: "_blank"
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_fortawesome_react_fontawesome__WEBPACK_IMPORTED_MODULE_1__["FontAwesomeIcon"], {
        icon: _fortawesome_free_solid_svg_icons__WEBPACK_IMPORTED_MODULE_3__["faShoppingBag"]
      }), " Product"), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("a", {
        className: "cpb-menu-link",
        href: previewLink,
        title: "Open frontend Product page in a new Tab",
        target: "_blank"
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_fortawesome_react_fontawesome__WEBPACK_IMPORTED_MODULE_1__["FontAwesomeIcon"], {
        icon: _fortawesome_free_regular_svg_icons__WEBPACK_IMPORTED_MODULE_2__["faEye"]
      }), " Preview")), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("div", {
        className: "cpb-menu-part"
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("button", {
        className: "cpb-menu-link cpb-menu-toggle-".concat(isAdmin ? 'on' : 'off'),
        title: "Toggle view between Admin and Customer mode",
        onClick: toggleAdmin
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_fortawesome_react_fontawesome__WEBPACK_IMPORTED_MODULE_1__["FontAwesomeIcon"], {
        icon: isAdmin ? _fortawesome_free_solid_svg_icons__WEBPACK_IMPORTED_MODULE_3__["faToggleOn"] : _fortawesome_free_solid_svg_icons__WEBPACK_IMPORTED_MODULE_3__["faToggleOff"]
      }), " Admin Mode"), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("button", {
        className: "cpb-menu-link",
        title: "Open support popup",
        onClick: onHelp
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_fortawesome_react_fontawesome__WEBPACK_IMPORTED_MODULE_1__["FontAwesomeIcon"], {
        icon: _fortawesome_free_regular_svg_icons__WEBPACK_IMPORTED_MODULE_2__["faQuestionCircle"]
      }), " Help"), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("button", {
        className: "cpb-menu-link\n                        ".concat(!notice || notice === 'done' ? 'cpb-menu-done' : 'cpb-menu-warning', "\n                        ").concat(isProcessing ? 'cpb-process' : ''),
        title: generatorNotice,
        onClick: toggleGeneratorPopup
      }, isProcessing ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(utils_icons_loading__WEBPACK_IMPORTED_MODULE_4__["default"], null) : !notice || notice === 'done' ? react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_fortawesome_react_fontawesome__WEBPACK_IMPORTED_MODULE_1__["FontAwesomeIcon"], {
        icon: _fortawesome_free_solid_svg_icons__WEBPACK_IMPORTED_MODULE_3__["faCheckCircle"]
      }) : react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_fortawesome_react_fontawesome__WEBPACK_IMPORTED_MODULE_1__["FontAwesomeIcon"], {
        icon: _fortawesome_free_solid_svg_icons__WEBPACK_IMPORTED_MODULE_3__["faExclamationTriangle"]
      }), "\xA0 Prices"), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement("button", {
        className: "cpb-menu-link cpb-menu-button",
        title: "Save this product configuration and generate product varians for every possible price",
        onClick: onSave
      }, react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(_fortawesome_react_fontawesome__WEBPACK_IMPORTED_MODULE_1__["FontAwesomeIcon"], {
        icon: _fortawesome_free_regular_svg_icons__WEBPACK_IMPORTED_MODULE_2__["faSave"]
      }), " Save")), react__WEBPACK_IMPORTED_MODULE_0___default.a.createElement(StatusBar, {
        Routing: Routing,
        updateProductVariants: updateProductVariants,
        updateProductData: updateProductData,
        Product: Product,
        variants: variants,
        Generator: Generator,
        updateGeneratorProcessing: updateGeneratorProcessing,
        updateGeneratorNotice: updateGeneratorNotice,
        generatorNotice: generatorNotice,
        toggleGeneratorPopup: toggleGeneratorPopup,
        pregeneratedProductName: pregeneratedProductName,
        resetProduct: resetProduct,
        settings: settings,
        updateProductLayer: updateProductLayer
      }));
    }
  }]);

  return ShopifyMenu;
}(react__WEBPACK_IMPORTED_MODULE_0___default.a.PureComponent);

_defineProperty(ShopifyMenu, "displayName", 'ShopifyMenu');

/* harmony default export */ __webpack_exports__["default"] = (ShopifyMenu);

/***/ })

}]);
//# sourceMappingURL=35.053d36c55bc5967fe179d76545038895f1621190.js.map?id=5a26b64c708a5ad7fc8f